export declare const ClassStoreSymbol: unique symbol;
export declare function makeReactive(value: any): any;
export declare function getDescriptors(store: any): {
    [x: string]: TypedPropertyDescriptor<any>;
} & {
    [x: string]: PropertyDescriptor;
};
export declare type DescriptorGroups = {
    state?: {
        [key: string]: PropertyDescriptor;
    };
    getters?: {
        [key: string]: PropertyDescriptor;
    };
    setters?: {
        [key: string]: PropertyDescriptor;
    };
    actions?: {
        [key: string]: PropertyDescriptor;
    };
    other?: {
        [key: string]: PropertyDescriptor;
    };
};
export declare function getDescriptorsGrouped(store: any, ignoreKeys?: string[]): DescriptorGroups;
