var C = Object.defineProperty;
var w = (s, t, e) => t in s ? C(s, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : s[t] = e;
var o = (s, t, e) => (w(s, typeof t != "symbol" ? t + "" : t, e), e);
import N from "fs-jetpack";
import f from "chalk";
import D from "lodash";
import i from "typescript";
const L = {};
function B(s, t) {
  let e = s != null ? s : t;
  return e.endsWith("Store") && (e = e.replace("Store", ""), e = e.charAt(0).toLowerCase() + e.slice(1)), "$" + e;
}
const P = "\x1B[0m";
f.cyanBright("[VUE CLASS STORES]");
function k(...s) {
  console.log(
    f.greenBright(" \u2713"),
    s.map((t) => f.dim(t)).join(" "),
    P
  );
}
function u(...s) {
  console.log(
    f.blueBright(" i"),
    s.map((t) => f.dim(t)).join(" "),
    P
  );
}
function j(...s) {
  console.log(
    s.map((t) => f.dim(t)).join(" "),
    P
  );
}
function I(...s) {
  const t = [f.yellowBright(" !")].join("");
  console.log(t, s.map((e) => f.dim(e)).join(" "));
}
const { factory: n } = i, x = class {
  constructor() {
    o(this, "program");
    o(this, "filePaths", []);
    o(this, "modules", []);
    o(this, "stores", []);
    o(this, "config");
    o(this, "compilerHost");
    o(this, "printer");
    o(this, "typeChecker");
    o(this, "parsedCommandLine");
  }
  init(t) {
    x.instance = this, this.config = t;
    const e = i.findConfigFile(t.projectRoot, i.sys.fileExists, "tsconfig.json");
    if (!e)
      throw new Error("Could not find a valid 'tsconfig.json'.");
    const r = i.readConfigFile(e, i.sys.readFile);
    this.parsedCommandLine = i.parseJsonConfigFileContent(
      r.config,
      i.sys,
      "./"
    ), this.setFilePaths(), this.compilerHost = i.createCompilerHost(this.parsedCommandLine.options), this.program = i.createProgram(this.filePaths, this.parsedCommandLine.options, this.compilerHost), this.printer = i.createPrinter({ newLine: i.NewLineKind.LineFeed }), this.typeChecker = this.program.getTypeChecker(), this.reloadModules();
  }
  setFilePaths() {
    const t = this.config.storesDirectory.find({
      directories: !1,
      files: !0,
      recursive: !0,
      matching: ["*Store.ts", "*store.ts"]
    }).map(
      (e) => i.sys.resolvePath(this.config.storesDirectory.path(e))
    );
    return this.filePaths = D.uniq(t.concat(...this.parsedCommandLine.fileNames.map(
      (e) => i.sys.resolvePath(e)
    )));
  }
  reloadModules() {
    this.setFilePaths(), this.modules = this.program.getSourceFiles().filter((t) => this.filePaths.includes(t.fileName)).map((t) => ({
      module: t,
      store: new b(t, this.config.storesPath)
    }));
  }
  process() {
    this.stores = [];
    for (const { module: t, store: e } of this.modules) {
      const r = this.processModule(t, e);
      !r || this.stores.push(r.finalize());
    }
  }
  writeFiles() {
    var d;
    const t = (d = this.stores) == null ? void 0 : d.length;
    if (!t) {
      I("No stores located... skipping code-gen.");
      return;
    }
    u("Located", f.reset(t), "stores:"), j(this.stores.map((y) => "   - " + f.reset(y.className)).join(`
`));
    const e = M(this.stores), r = i.createSourceFile(this.config.storesFileName, "", i.ScriptTarget.ES2022, !1, i.ScriptKind.TS), a = this.printer.printList(i.ListFormat.MultiLine, n.createNodeArray(e), r);
    this.config.storesDirectory.write(this.config.storesFileName, a), this.config.storesDirectory.write(
      "StoreMeta.json",
      JSON.stringify(this.stores, null, 2)
    ), k(
      "Generated stores vue declaration file at:",
      f.reset((void 0)(this.config.storesPath, this.config.storesFileName).replace(this.config.projectRoot, ""))
    );
  }
  rebuild() {
    this.process(), this.writeFiles();
  }
  processModule(t, e) {
    var r, a, d, y, h;
    for (let c of t.statements) {
      if (i.isVariableStatement(c) && ((r = c.modifiers) == null ? void 0 : r.some((S) => S.kind === i.SyntaxKind.ExportKeyword)) && ((d = (a = c == null ? void 0 : c.declarationList) == null ? void 0 : a.declarations) == null ? void 0 : d.length) === 1) {
        const S = c.declarationList.declarations[0];
        i.isIdentifier(S.name) && (e.exportName = S.name.text);
      }
      if (i.isClassDeclaration(c) && ((y = c.heritageClauses) == null ? void 0 : y.some((F) => F.token !== i.SyntaxKind.ExtendsKeyword ? !1 : F.types.some((l) => {
        var v;
        if (!i.isExpressionWithTypeArguments(l) || !i.isCallExpression(l.expression))
          return !1;
        const p = l.expression;
        return i.isIdentifier(p.expression) ? ((v = p.expression.text) == null ? void 0 : v.toLowerCase()) === "store" : !1;
      }))) && i.isIdentifier(c.name)) {
        e.className = c.name.text;
        for (let l of c.members)
          if (i.isPropertyDeclaration(l)) {
            if (!((h = l.modifiers) != null && h.some((p) => p.kind === i.SyntaxKind.StaticKeyword)))
              continue;
            if (i.isIdentifier(l.name) && l.name.text === "vueBinding" && i.isStringLiteral(l.initializer)) {
              e.vueBinding = l.initializer.text;
              break;
            }
          }
        const F = [];
        for (let l of c.members)
          if (i.isMethodDeclaration(l) && i.isIdentifier(l.name)) {
            const p = new E(l, l.name.text);
            F.push(p);
            for (let v of l.parameters)
              i.isIdentifier(v.name) && p.addParam(v);
          }
        e.actions = F;
      }
    }
    return e.isValid() ? e : void 0;
  }
  isStoreFile(t) {
    return this.stores.some((e) => e.absFilePath === t);
  }
  getStoreByFilePath(t) {
    return this.stores.find((e) => e.absFilePath === t);
  }
};
let g = x;
o(g, "instance");
class b {
  constructor(t, e) {
    o(this, "absFilePath");
    o(this, "relStoreFilePath");
    o(this, "name");
    o(this, "className");
    o(this, "exportName");
    o(this, "vueBinding");
    o(this, "actions", []);
    this.absFilePath = t.fileName, this.name = (void 0)(t.fileName), this.relStoreFilePath = (void 0)(e, t.fileName);
  }
  isValid() {
    return this.className !== void 0 && this.exportName !== void 0;
  }
  finalize() {
    return this.formatVueBinding(), this;
  }
  formatVueBinding() {
    this.vueBinding || (this.vueBinding = B(this.vueBinding, this.className));
  }
}
class E {
  constructor(t, e) {
    o(this, "name");
    o(this, "params", []);
    o(this, "method");
    o(this, "signature");
    this.method = t, this.name = e, this.signature = g.instance.typeChecker.getSignatureFromDeclaration(this.method);
    for (let r of this.signature.parameters) {
      const a = g.instance.typeChecker.typeToString(g.instance.typeChecker.getTypeAtLocation(r.valueDeclaration));
      let d;
      i.isParameter(r.valueDeclaration) && r.valueDeclaration.initializer && (d = r.valueDeclaration.initializer.getText()), this.params.push({
        name: r.name,
        type: a,
        defaultValue: d
      });
    }
  }
  addParam(t) {
  }
  toJSON() {
    return {
      name: this.name,
      params: this.params
    };
  }
}
function M(s) {
  const t = s.map((a) => n.createPropertySignature(
    void 0,
    n.createIdentifier(a.vueBinding),
    void 0,
    n.createTypeQueryNode(n.createIdentifier(a.exportName), void 0)
  )), e = s.map((a) => n.createImportDeclaration(
    void 0,
    n.createImportClause(
      !1,
      void 0,
      n.createNamedImports([
        n.createImportSpecifier(!1, void 0, n.createIdentifier(a.exportName))
      ])
    ),
    n.createStringLiteral(`./${a.relStoreFilePath.replace(".ts", "")}`),
    void 0
  ));
  return [
    n.createModuleDeclaration(
      [n.createModifier(i.SyntaxKind.DeclareKeyword)],
      n.createStringLiteral("@vue/runtime-core"),
      n.createModuleBlock([
        ...e,
        n.createInterfaceDeclaration(
          void 0,
          n.createIdentifier("ComponentCustomProperties"),
          void 0,
          void 0,
          t
        )
      ]),
      i.NodeFlags.ExportContext | i.NodeFlags.ContextFlags
    ),
    n.createExportDeclaration(
      void 0,
      !1,
      n.createNamedExports([]),
      void 0,
      void 0
    )
  ];
}
const R = {
  storesFileName: "stores.d.ts"
}, m = {
  projectRoot: null,
  projectRootDirectory: null,
  storesPath: null,
  storesDirectory: null,
  storesFileName: null,
  ...R
};
function H(s) {
  for (let r in s)
    s[r] && (m[r] = s[r]);
  let t;
  const e = new g();
  return {
    name: "class-stores-loader",
    async configResolved(r) {
      m.projectRoot = r.root, m.storesPath = L.resolve(m.projectRoot, m.storesPath), m.storesDirectory = N.cwd(m.storesPath), m.projectRootDirectory = N.cwd(m.projectRoot), e.init(m), e.process();
    },
    configureServer(r) {
      t = r, t.watcher.on("all", (a, d, y) => {
        if (!["add", "change", "unlink"].includes(a) || K(d) || !d.startsWith(m.storesPath))
          return;
        if (e.reloadModules(), ["change", "unlink"].includes(a)) {
          const c = e.getStoreByFilePath(d);
          if (!c)
            return;
          u(a === "unlink" ? `Store file deletion detected: ${c.className}` : `Store file change detected: ${c.className}`), u("Rebuilding stores..."), e.rebuild();
          return;
        }
        let h = e.getStoreByFilePath(d);
        h || (u(`New file detected: ${d}`), u("Rebuilding store meta..."), e.process()), h = e.getStoreByFilePath(d), h && (u(`Addition was a new store: ${h.className}`), u("Rebuilding stores..."), e.rebuild());
      });
    },
    buildStart(r) {
      e.writeFiles();
    }
  };
}
function K(s) {
  return [
    m.storesDirectory.path(m.storesFileName)
  ].includes(s);
}
export {
  H as ClassStoresPlugin,
  g as Context,
  b as StoreMeta
};
//# sourceMappingURL=index.js.map
