export declare type SubscribeOptions = {
    detached?: boolean;
    onCleanup?: () => void;
};
export declare type SubscriptionCallback = (...args: any[]) => any;
export declare type SubscriptionCallbackInfo = {
    callback: SubscriptionCallback;
    options: SubscribeOptions;
    disposer: () => void;
};
export declare class Subscription {
    callbacks: SubscriptionCallbackInfo[];
    addSubscription(callback: SubscriptionCallback, options?: SubscribeOptions): SubscriptionCallbackInfo;
    subscribe(callback: SubscriptionCallback, options?: SubscribeOptions): () => void;
    trigger(...args: any[]): void;
    triggerPiped(...args: any[]): any[];
}
